/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

diaryServices.factory('ActionFactory', function ($q, $http, Configuration,ActionDefinitions, $log,$filter) {
    
    var checkDate = function (date){
        var newDate;
        
        if (date <= new Date())
        {
           newDate = new Date(); 
        }
        else
        {
            return date
        }
    }

    var buildNewCompletedAction = function( options ){
        var action = buildNewPendingAction( options );
        action.dateCompleted = new Date();
        action.success = true;
        return action;
    };
    
    var buildNewPendingAction = function ( options ){
        var action = {};
        action.id = 0;
        action.seq = 0;
        action.actionType = options.actionType;
        action.actionPriority = options.actionPriority;
        action.actorPersonId = options.actorPersonId;
        action.acteePersonId = options.acteePersonId;
        action.comment = options.comment;
        action.createdByPersonId = options.createdByPersonId;
        action.dateCompleted = null;
        action.dateCreated = new Date();
        if(options.scheduledDate != null){
        action.dateScheduled = options.scheduledDate;
        }
        else{
            action.dateScheduled = new Date();
            }
        action.requestId = options.requestId;
        action.success = false;
        return action;
        
    };

    // check if an action type already exists on a request;
    
    var checkActionTypeExists = function( request,actionTypeId ){
        var exists = false;
        angular.forEach(request.actions, function(each){
            if( !exists ){
                if( each.actionType.id === actionTypeId ){
                    if((each.actionType.id === ActionDefinitions.get().type.delivery || each.actionType.id === ActionDefinitions.get().type.collection || each.actionType.id === ActionDefinitions.get().type.changeover) && (each.success === false && each.dateCompleted === null) || (each.success == true))
                    exists = true;
                };
            };
        });
        return exists;
    };
    
    var checkActionTypeSuccessful = function( request,actionTypeId ){
      var succeeded = false;
       angular.forEach(request.actions, function(each){
            if( !succeeded ){
                if( each.actionType.id === actionTypeId && each.success ){
                    succeeded = true;
                };
            };
        });
      
      
      return succeeded;
    };
    
    
    var actionSearch = function (filter) {
        //var databaseDoc = angular.copy(data.doc);

        var getPromise = $q.defer();
        // var credentials = { username: user, password: pass };
        $log.info("pre get search requests");
        $http.post(Configuration.getConfiguration().actionSearchUrl, filter).then(function (data) {
            $log.info(data);
            getPromise.resolve(data); // return token
        },
                function (error) {
                    //$log.error( error );
                    getPromise.resolve(""); // on error return empty token
                });

        return getPromise.promise;

    };
    
    

    return{
       buildNewCompletedAction: buildNewCompletedAction,
       buildNewPendingAction: buildNewPendingAction,
       checkActionTypeExists: checkActionTypeExists,
       checkActionTypeSuccessful : checkActionTypeSuccessful,
       actionSearch: actionSearch,
       checkDate: checkDate
    };

});